package com.iformall.controller.basic;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.WxMall;
import com.iformall.service.WxMallService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("wxMall")
public class WxMallController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxMallService wxMallService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "商城")
    public ResultData list(@ModelAttribute WxMall wxMall, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxMallController::list");
        if (null == wxMall) wxMall = new WxMall();
        final PageInfo<WxMall> page = wxMallService.listAsPage(wxMall, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口(1)")
    @PostMapping("add")
    @SystemControllerLog(description = "商城-新增")
    public ResultData add(@RequestBody WxMall wxMall) {
        logger.debug("[" + getIpAddr() + "] WxMallController::add");
        //Assert.notNull(wxMall.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxMallService.save(wxMall);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "商城-更新")
    public ResultData update(@RequestBody WxMall wxMall) {
        logger.debug("[" + getIpAddr() + "] WxMallController::update");
        wxMallService.update(wxMall);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "商城-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMallController::delete");
        wxMallService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "商城-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMallController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxMallService.getById(id));
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/mallinfoExt")
    @SystemControllerLog(description = "商城-查询")
    public ResultData mallinfoExt() {
        logger.debug("[" + getIpAddr() + "] WxMallController::mallinfoExt");
        return new ResultData(wxMallService.getByTenantIdExt(getTenantId()));
    }

    @ApiOperation("查询当前mall的信息")
    @GetMapping("/mallinfo")
    @SystemControllerLog(description = "商城-当前查询")
    public ResultData mallinfo() {
        logger.debug("[" + getIpAddr() + "] WxMallController::mallinfo");
        return new ResultData(wxMallService.getByTenantId(getTenantId()));
    }


}
